# Летняя школа DevOps/DevSecOps 2023 - Инструкция по подготовке к школе. Что нужно установить до начала тренингов, что мы будем изучать

**ВАЖНО:** подписывайтесь на [официальный канал](https://t.me/+5USjxpz4RU8yNTIy) в телеграмм, чтобы не пропустить важную информацию

## Обновления

- [добавлены ссылки](#программа) на трансляции первого дня: [часть 1](https://youtube.com/live/SXDMqgUalnQ?feature=share), [часть 2](https://youtube.com/live/5NDAId35gpY?feature=share)
- добавлено задание первого дня: [тест по командам докер](https://forms.yandex.ru/u/64a1d7e2eb61466cf9722807/) и отработка практики -  [создание простого образа](https://forms.yandex.ru/u/64a39f7f3e9d08a0ba6da987/) 
- обратите внимание: добавлен раздел [Необходимые действия](#необходимые-действия). Обязательно ознакомьтесь
- [добавлены презентации](#программа) первого дня
- [добавлены ссылки](#программа) на трансляции второго дня: [часть 1](https://youtube.com/live/hnvUaxuspU8?feature=share), [часть 2](https://www.youtube.com/live/hnvUaxuspU8?feature=share&t=7171)
- добавлен раздел [учебные примеры](#учебные-примеры) где доступны демо приложения, которые разбирались на занятиях
- [добавлены ссылки](#программа) на трансляции третьего дня: [часть 1](https://youtube.com/live/LszI5cYJH68?feature=share), [часть 2](https://youtube.com/live/_yKJgnJxQS0?feature=share)

## Цель обучения

Освоить современные практики непрерывной интеграции и доставки нового кода (Continuous Integration / Continuous Delivery, CI/CD) на примере технологий GitLab/GitFlow и Docker.

Участники разберутся с принципами CI/CD, научатся создавать пайплайны на примере Gitlab CI, освоят методы и инструменты контейнеризации на примере Docker, научатся строить цепочку поставки, включающую все основные стадии - сборка, тестирование, упаковка, сканирование.

Слушатели получат понимание о современном жизненном цикле безопасной разработки приложений, приобретут навык работы с современными технологиями безопасного тестирования (SAST, DAST) тестирования, сканирования контейнеров и других механизмах безопасности, научатся строить цепочку поставки, включающую все основные стадии - сборка, тестирование, упаковка, сканирование, а также научатся встраивать инструменты тестирования в безопасную цепочку поставки.

## Темы

В рамках обучения мы рассматриваем следующие темы:

- [ ] Введение в DevOps/DevSecOps
- [ ] Технологии контейнеризации
- [ ] Обеспечение безопасности контейнеров
- [ ] Автоматизация цепочки поставки
- [ ] Безопасность цепочки поставки

## Программа
Посмотреть программу школы [можно здесь](https://git.miem.hse.ru/devops_public/summerschool2023/-/blob/master/files/Programm_summer_DevOps_DevSecOps_2023.pdf)

В таблице ниже будут появляться ссылки на трансляции и дополнительные материалы

| Дата       | Время         | Трансляция                                                                                                  | Материалы                                                                                                                                                                                                                                                  | Задание                                                                                                                                                       | Тренер                      | Баллы | Блокирующий |
|------------|---------------|-------------------------------------------------------------------------------------------------------------|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|---------------------------------------------------------------------------------------------------------------------------------------------------------------|-----------------------------|-------|-------------|
| 03.07.2023 | 17.00 – 18.20 | [Введение в DevOps/DevSecOps](https://youtube.com/live/SXDMqgUalnQ?feature=share)                           | [слайды](https://git.miem.hse.ru/devops_public/summerschool2023/-/blob/master/files/1%20-%20%D0%92%D0%B2%D0%B5%D0%B4%D0%B5%D0%BD%D0%B8%D0%B5%20%D0%B2%20DevOps-DevSecOps.pdf)                                                                              |                                                                                                                                                               | Башун В.В.                  |       |             |
| 03.07.2023 | 18.30 – 20.00 | [Технологии контейнеризации. Практикум](https://youtube.com/live/5NDAId35gpY?feature=share)                 | [слайды](https://git.miem.hse.ru/devops_public/summerschool2023/-/blob/master/files/2%20-%20%D0%A2%D0%B5%D1%85%D0%BD%D0%BE%D0%BB%D0%BE%D0%B3%D0%B8%D0%B8%20%D0%BA%D0%BE%D0%BD%D1%82%D0%B5%D0%B9%D0%BD%D0%B5%D1%80%D0%B8%D0%B7%D0%B0%D1%86%D0%B8%D0%B8.pdf) | [тест по командам докер](https://forms.yandex.ru/u/64a1d7e2eb61466cf9722807/) [создание простого образа](https://forms.yandex.ru/u/64a39f7f3e9d08a0ba6da987/) | Башун В.В. / Курмашева Т.А. |       |             |
| 05.07.2023 | 17.00 – 18.20 | [Создание образов. Продвинутое управление контейнерами](https://youtube.com/live/hnvUaxuspU8?feature=share) |                                                                                                                                                                                                                                                            |                                                                                                                                                               | Башун В.В. / Курмашева Т.А. |       |             |
| 05.07.2023 | 18.30 – 20.00 | [Обеспечение безопасности контейнеров](https://www.youtube.com/live/hnvUaxuspU8?feature=share&t=7171)       |                                                                                                                                                                                                                                                            |                                                                                                                                                               | Башун В.В. / Курмашева Т.А. |       |             |
| 07.07.2023 | 17.00 – 18.20 | [Автоматизация цепочки поставки. CI/CD](https://youtube.com/live/LszI5cYJH68?feature=share)                 |                                                                                                                                                                                                                                                            |                                                                                                                                                               | Башун В.В. / Курмашева Т.А. |       |             |
| 07.07.2023 | 18.30 – 20.00 | [Безопасность цепочки поставки](https://youtube.com/live/_yKJgnJxQS0?feature=share)                         |                                                                                                                                                                                                                                                            |                                                                                                                                                               | Башун В.В. / Курмашева Т.А. |       |             |

При выполнении заданий не забывайте пользоваться так же [справочными материалами](#полезные-ссылки-и-документация)

## Требования к участникам

Для прохождения летней школы не требуется сверх-навыков и подготовки, мы начинаем с достаточно базовых вещей.

Однако DevSecOps - это тема на стыке разработки, тестирования, администрирования и безопасности, поэтому некоторый бекграунд все же требуется.

Вы должны уметь работать с linux в командной строке и иметь базовые навыки администрирования. Вам придется устанавливать и настраивать необходимые инструмены для devops и работы с контейнерами.

Вы должны иметь базовые навыки разработки на каком то языке и точно должны уметь читать программный код.

Базовые навыки, такие как работа с системой контроля версий (git) и общее представление о gitflow, так же нужны.

Не стесняйтесь пользоваться [справочными материалами](#полезные-ссылки-и-документация), а так же загляните в раздел [самоподготовка](#самоподготовка)

## Самоподготовка

Чтобы помочь вам освежить базовые навыки, мы подготовили несколько дополнительных материалов.

### git

Инструменты совместной работы (git) является одной из тем, которые мы рассматриваем, но предполагается, что вы знаете основы работы с git.

Некоторые базовые вещи [разбираются в этом видео](https://youtu.be/U0yPHH72l1k)

Пожалуйста, ознакомьтесь с ним заранее, если у вас нет большого опыта работы с git.

Если у вас нет опыта командной работы, вы не знаете про ветки и gitflow (и у вас много свободного времени), можно так же посмотреть долгий материал [Основы Git. Основные операции. Мастер-класс «Ветвление в Git и управление ветками».](https://youtu.be/YyJBk5b9f7Q)

Вам так же надо будет установить клиент git на той платформе, где вы будете практиковаться. Как это сделать - см. раздел [необходимое ПО](#необходимое-по)

### docker

Вы пока не знаете ничего про докер, но вам нужно его поставить заранее (в том числе, чтобы пройти [стартовое тестирование](#стартовое-тестирование))
Если вы ранее не ставили себе docker, посмотрите небольшое [начальное видео](https://youtu.be/uZdH9yg9BQk)

## Стартовое тестирование

Пожалуйста, попробуйте свои силы и пройдите [стартовое тестирование](https://forms.yandex.ru/u/6496fdb73e9d086765be195b/)

Не пугайтесь, если не знаете как ответить на вопрос. В части вопросов по докеру, пожалуйста, ознакомьтесь с [начальным видео](https://youtu.be/uZdH9yg9BQk) и [установите себе на платформу докер](#тема-docker)

## Необходимые действия

1. Вам необходимо зарегистрироваться на платформе [GitLab (DevSecOps platform)](https://gitlab.com/)
  - [ ] Все задания, требующие использования репозитория и запуска CI/CD пайплайнов, будет делать на этой платформе.

2. Вам необходимо зарегистрироваться на  [Docker Hub](https://hub.docker.com/)
  - [ ] Сюда мы будет загружать полученные образы контейнеров.


## Необходимое ПО

Для выполнения практических заданий вам понадобится подготовить свой компьютер, установив на него необходимое программное обеспечение.

Мы рекомендуем использовать docker под ОС Linux (если у вас другая ОС, можно развернуть ее, например, в virtual box).
Общая рекомендация - для выполнения заданий поднимите виртуальную машину linux (например ubuntu) и в ней уже установите docker.

- [ ] Клиент git. [Интструкция по установке](#тема-git). 
- [ ] Docker (или другое CRI-совместимое решение). [Инструкция по установке](#тема-docker)
- [ ] Рекомендуем Вам установить Python3 и среду разработки к нему для выполнения домашних заданий.
    - Если Вы планируете использовать другой язык -- предустановите его
- [ ] gitlab-runner. Он вам понадобится ближе к третьему дню летней школы, но не забудьте его [установить и настроить](#установка-gitlab-runner).

**БУДЕТ ДОПОЛНЕНО**

### Учебные примеры

Учебные примеры с занятий доступны [здесь](https://git.miem.hse.ru/devops_public/examples/)

- [ ] Демо 1. [Простой пример](https://git.miem.hse.ru/devops_public/examples/demo1) упаковки питон приложения в контейнер 
- [ ] Демо 2. [Два примера веб-приложения](https://git.miem.hse.ru/devops_public/examples/demo2) в контейнер
- [ ] Демо 3. [Многоступенчатая сборка](https://git.miem.hse.ru/devops_public/examples/demo3) на примере простого go приложения

### Полезные ссылки и документация

#### Материалы по Git

- Установка git client
    - [Установка Git](https://git-scm.com/book/ru/v2/%D0%92%D0%B2%D0%B5%D0%B4%D0%B5%D0%BD%D0%B8%D0%B5-%D0%A3%D1%81%D1%82%D0%B0%D0%BD%D0%BE%D0%B2%D0%BA%D0%B0-Git) 
    - [Getting started](https://git-scm.com/book/en/v2/Getting-Started-Installing-Git) 
    - [Установка на windows](https://git-scm.com/download/win) 

- [Книга по Git. Много информации](https://git-scm.com/book/ru/v2/)

#### Материалы по Gitlab

- [Run GitLab Runner in a container](https://docs.gitlab.com/runner/install/docker.html)
- [Регистрация раннера](https://docs.gitlab.com/runner/register/index.html#docker)

#### Материалы по Docker

- [Основная документация Docker](https://docs.docker.com/)
- [Установка Docker](https://docs.docker.com/engine/install/)
- [Docker getting started](https://docs.docker.com/get-started/)
- [Справка по написанию Dockerfile](https://docs.docker.com/engine/reference/builder/)
- [Запуск команды в контейнере](https://docs.docker.com/engine/reference/commandline/run/)
- [Docker desktop под windows](https://docs.docker.com/desktop/install/windows-install/)
- [Контейнеры в Windows](https://learn.microsoft.com/ru-ru/virtualization/windowscontainers/quick-start/set-up-environment?tabs=Windows-Server)

#### Установка gitlab-runner

**БУДЕТ ДОПОЛНЕНО** скоро здесь будет инструкция.

## Авторы
[В. Башун](mailto:vbashun@hse.ru), Т. Курмашева. 

## Контакты
- [ ] [Официальный канал Telegram](https://t.me/+5USjxpz4RU8yNTIy)
- [ ] Основной адрес электронной почты [dpo_devops@miem.hse.ru](mailto:dpo_devops@miem.hse.ru)
- [ ] Telegram: [@vbashun](https://t.me/vbashun)

## Contributing

Мы проводим летние/зимние школы, а так же учебные курсы по темам DevOps/DevSecOps.

Если у вас есть комментарии, замечания или предложения по доработке курсов, пожалуйста, [свяжитесь с нами](#контакты)

Если вы готовы сотрудничать или поучаствовать в разработке учебных программ или материалов, будем рады обсудить.


